//+------------------------------------------------------------------+
//|                                                       Jeeves.mq4 |
//+------------------------------------------------------------------+
#property copyright "Johnj"
#property link      "john.jeeves2@gmail.com"

#property indicator_chart_window
#property indicator_buffers 0

//
//
//
//
//

extern int   StartHour    =  1;
extern int   BreakOut     = 30;
extern int   StopLoss     = 15;
extern int   Tp1          = 30;
extern int   Tp2          = 0;
extern int   Tp3          = 0;
extern int   Tp4          = 0;

extern color ColorUpLines = Aqua;
extern color ColorDnLines = Aqua;
extern color ColorUpBreak = Lime;
extern color ColorDnBreak = Lime;
extern color ColorUpStop  = Red;
extern color ColorDnStop  = Red;
extern color ColorClose   = Black;

extern int   LabelShift   = 3;
extern bool  ExtendRight  = False;

extern bool alertsOn       = true;
extern bool alertsOnClosed = false;
extern bool alertsMessage  = false;
extern bool alertsSound    = true;
extern bool alertsEmail    = false;

//
//
//
//
//

double breakOutLine[];
int    pipMultiplier;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(1);
   SetIndexBuffer(0,breakOutLine); SetIndexStyle(0,DRAW_NONE);
   return(0);
}
int deinit()
{
   for (int i=-2;i<12;i++) { ObjectDelete("Jeeves"+100*i); ObjectDelete("Jeeves"+100*i+i); }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int    counted_bars=IndicatorCounted();
   int    i,limit;

   if(Period()>PERIOD_H4) { Comment("Can not display data on time frame greater than 4 hour"); return(0);}
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         if (Digits==3 || Digits==5)
               pipMultiplier=10;   
         else  pipMultiplier=1;     

   //
   //
   //
   //
   //

   for(i=limit; i >= 0; i--)
   {
      breakOutLine[i] = breakOutLine[i+1];
         string day   = TimeToStr(Time[i],TIME_DATE);
         int    shift = iBarShift(NULL,PERIOD_H1,StrToTime(day+" "+StartHour+":0"));
      breakOutLine[i] = iClose(NULL,PERIOD_H1,shift+1);
   }   

   //
   //
   //
   //
   //
   
   for(i=0; i < Bars ; i++)  if (breakOutLine[i]!=breakOutLine[i+1]) break;
      string name = "Jeeves";           
      
      double pivot;
         //if (TimeDayOfWeek(iTime(NULL,PERIOD_D1,1))==0)
               //pivot = (iHigh(NULL,PERIOD_D1,2)+iLow(NULL,PERIOD_D1,2)+iClose(NULL,PERIOD_D1,2))/3;
         //else  pivot = (iHigh(NULL,PERIOD_D1,1)+iLow(NULL,PERIOD_D1,1)+iClose(NULL,PERIOD_D1,1))/3;

      //
      //
      //
      //
      //
                              
      makeLevel(name,i, 1,-2,pivot                   ,"pivot");
      makeLevel(name,i, 1,-1,0                       ,"");
      makeLevel(name,i, 1, 0,StopLoss                ,"stop loss");
      makeLevel(name,i,-1, 1,StopLoss                ,"stop loss");
      makeLevel(name,i, 1, 2,BreakOut                ,"entry long");
      makeLevel(name,i,-1, 3,BreakOut                ,"entry short");
      makeLevel(name,i, 1, 4,BreakOut+Tp1            ,"take profit long 1");
      makeLevel(name,i,-1, 5,BreakOut+Tp1            ,"take profit short 1");
      makeLevel(name,i, 1, 6,BreakOut+Tp1+Tp2        ,"take profit long 2");
      makeLevel(name,i,-1, 7,BreakOut+Tp1+Tp2        ,"take profit short 2");
      makeLevel(name,i, 1, 8,BreakOut+Tp1+Tp2+Tp3    ,"take profit long 3");
      makeLevel(name,i,-1, 9,BreakOut+Tp1+Tp2+Tp3    ,"take profit short 3");
      makeLevel(name,i, 1,10,BreakOut+Tp1+Tp2+Tp3+Tp4,"take profit long 4");
      makeLevel(name,i,-1,11,BreakOut+Tp1+Tp2+Tp3+Tp4,"take profit short 4");
      
   return(0);
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void makeLevel(string name,int i,int multiplier,int level,double value,string message)
{
   double thePrice = breakOutLine[0]+(pipMultiplier*multiplier*value*Point);
   string theName  = name+100*level;
   int    shift    = 0;

   if (level==-2)
      {
         thePrice = value;
         shift    = 15;
      }

   //
   //
   //
   //
   //
                  
   if(ObjectFind(theName) == -1)
	  	ObjectCreate(theName,OBJ_TREND,0,Time[i],0,Time[0]);
         ObjectSet(theName,OBJPROP_PRICE1,thePrice);
         ObjectSet(theName,OBJPROP_PRICE2,thePrice);
         ObjectSet(theName,OBJPROP_TIME1 ,Time[0]);
         ObjectSet(theName,OBJPROP_TIME2 ,Time[i+shift]);
         if (level>-2)
         ObjectSet(theName,OBJPROP_STYLE ,STYLE_SOLID);
         ObjectSet(theName,OBJPROP_BACK  ,true);
   
         if (!ExtendRight) ObjectSet(theName,OBJPROP_RAY   ,false);
         
         color theColor;
         if (level > 3)
            {
               if (multiplier==1)         
                     theColor = ColorUpLines;
               else  theColor = ColorDnLines;                    
            }
         else            
            {
               if (level > 1)
               {
                  if (multiplier==1)         
                        theColor = ColorUpBreak;
                  else  theColor = ColorDnBreak;
               }
               else
                  if (level > -1)
                  {
                     if (multiplier==1)         
                           theColor = ColorUpStop;
                     else  theColor = ColorDnStop;
                  }                               
                  else theColor = ColorClose;
            }               

         //
         //
         //
         //
         //
         
         ObjectSet(theName,OBJPROP_COLOR,theColor);

   //
   //
   //
   //
   //

   theName = theName+level;
      if(ObjectFind(theName) == -1)
	    	ObjectCreate(theName,OBJ_ARROW,0,Time[i],thePrice);
            ObjectSet(theName,OBJPROP_ARROWCODE,5);
            ObjectSet(theName,OBJPROP_PRICE2,thePrice);
            ObjectSet(theName,OBJPROP_TIME1 ,Time[i+shift]);
            ObjectSet(theName,OBJPROP_COLOR ,theColor);
        
   //   
   //
   //
   //
   //
   
   if (alertsOn && level!=-1)
   {
      message = DoubleToStr(thePrice,Digits)+" "+message;
      
      //
      //
      //
      //
      //
      
         if (alertsOnClosed)
               i = 1;
         else  i = 0;
         if ((thePrice-Close[i])*(thePrice-Close[i+1])<0)
         {
            if (multiplier==1)
               {
                  if (Close[i]>thePrice)
                          doAlert(message+" crossed up");
                  else    doAlert(message+" reverted");
               }
            else
               {
                  if (Close[i]<thePrice)
                          doAlert(message+" crossed down");
                  else    doAlert(message+" reverted");
               }                  
         }
   }
}


//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," jeeves "+doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Jeeves "),message);
             if (alertsSound)   PlaySound("the_pips.wav");
      }
}

